summaryrefslogtreecommitdiff
path: root/script
diff options
context:
space:
mode:
authorLeah Rowe <leah@libreboot.org>2023-10-05 23:50:31 +0100
committerLeah Rowe <leah@libreboot.org>2023-10-06 01:16:39 +0100
commit176722a841e59f4a6664bad45dc9344364a4a166 (patch)
tree33317d5e0966c4b5ffe1b2f0392233a4ccc52da4 /script
parent9d419e77a0621ddf8398edecb40ddedc3388dc42 (diff)
unify handle/make/* into build/project/trees
Just one script. Just one. Signed-off-by: Leah Rowe <leah@libreboot.org>
Diffstat (limited to 'script')
-rwxr-xr-xscript/build/boot/roms8
-rwxr-xr-xscript/build/project/trees (renamed from script/handle/make/config)161
-rwxr-xr-xscript/build/release/src8
-rwxr-xr-xscript/handle/make/file40
-rwxr-xr-xscript/update/blobs/download2
5 files changed, 113 insertions, 106 deletions
diff --git a/script/build/boot/roms b/script/build/boot/roms
index f9634ce6..9736ee7f 100755
--- a/script/build/boot/roms
+++ b/script/build/boot/roms
@@ -128,7 +128,7 @@ prepare_target()
memtest_bin="memtest86plus/build${arch#*_}/memtest.bin"
[ "${payload_memtest}" != "y" ] || [ -f "${memtest_bin}" ] || \
- x_ ./handle make file -b ${memtest_bin%/*}
+ x_ ./build project trees -b ${memtest_bin%/*}
x_ rm -f "${romdir}/"*
@@ -145,7 +145,7 @@ build_dependency_seabios()
|| [ ! -f elf/seabios/default/libgfxinit/bios.bin.elf ] \
|| [ ! -f elf/seabios/default/vgarom/bios.bin.elf ] \
|| [ ! -f elf/seabios/default/normal/bios.bin.elf ]; then
- x_ ./handle make config -b seabios
+ x_ ./build project trees -b seabios
fi
}
@@ -173,7 +173,7 @@ build_dependency_uboot()
{
[ "${payload_uboot}" = "y" ] || return 0
- x_ ./handle make config -b u-boot ${board}
+ x_ ./build project trees -b u-boot ${board}
ubdir="elf/u-boot/${board}/${uboot_config}"
ubootelf="${ubdir}/u-boot.elf"
[ ! -f "${ubootelf}" ] && [ -f "${ubdir}/u-boot.bin" ] && \
@@ -210,7 +210,7 @@ build_roms()
"${cbcfg}" "${board}" "${displaymode}" "${initmode}" \
1>&2 && return 0
- x_ ./handle make config -b coreboot ${board}
+ x_ ./build project trees -b coreboot ${board}
_cbrom="elf/coreboot/${board}/${initmode}_${displaymode}"
[ "${initmode}" = "normal" ] && \
diff --git a/script/handle/make/config b/script/build/project/trees
index 694119c4..02481f02 100755
--- a/script/handle/make/config
+++ b/script/build/project/trees
@@ -9,36 +9,81 @@ set -u -e
. "include/err.sh"
. "include/option.sh"
-. "include/make.sh"
read projectname < projectname
-read our_version < version
+read version < version
-export LOCALVERSION="-${projectname}-${our_version}"
+export LOCALVERSION="-${projectname}-${version}"
eval "$(setvars "" arch cfgsdir codedir config config_name crossgcc_ada mode \
- elfdir listfile project romtype target target_dir targets tree cbfstool)"
+ elfdir listfile project romtype target target_dir targets tree cbfstool _f)"
tmpclean="$(mktemp -d -t makeclean.XXXXXXXXXX)"
-# main() is in include/make.sh
+main()
+{
+ while getopts b:m:u:c:x: option
+ do
+ _f="${1}"
+ case "${1}" in
+ -b) : ;;
+ -u) mode="oldconfig" ;;
+ -m) mode="menuconfig" ;;
+ -c) mode="distclean" ;;
+ -x) mode="crossgcc-clean" ;;
+ *) err "Invalid option" ;;
+ esac
+ shift; project="${OPTARG}"; shift
+ done
+ [ -z ${_f} ] && err "flag not specified (-m, -u, -b, -c or -x)"
+ [ -z ${project} ] && err "project name not specified"
+
+ if [ ! -f "config/${project}/build.list" ]; then
+ build_projects $@
+ else
+ build_targets $@
+ fi
+}
+
+build_projects()
+{
+ [ $# -gt 0 ] && x_ ./build project trees ${_f} ${@}
+ codedir="${project}"
+
+ [ -d "${codedir}" ] || x_ ./update project repo "${codedir%/*}"
+ [ -d "${codedir}" ] || \
+ err "build_targets: ${codedir%/*} not downloaded"
+
+ if [ "${project}" = "uefitool" ]; then
+ (
+ x_ cd uefitool
+ cmake UEFIExtract/ || [ -f Makefile ] || \
+ err "build_targets: !cmake UEFIExtract/"
+ )
+ fi
+
+ [ "${mode}" = "distclean" ] && mode="clean"
+ run_make_command || return 0
+}
-handle_dependencies()
+build_targets()
{
elfdir="elf/${project}"
cfgsdir="config/${project}"
- [ -d "${cfgsdir}" ] || fail "directory, ${cfgsdir}, does not exist"
+ [ -d "${cfgsdir}" ] || err "directory, ${cfgsdir}, does not exist"
listfile="${cfgsdir}/build.list"
- [ -f "${listfile}" ] || fail "list file, ${listfile}, does not exist"
+ [ -f "${listfile}" ] || err "list file, ${listfile}, does not exist"
# Build for all targets if no argument is given
targets=$(listitems "${cfgsdir}") || \
- fail "Cannot get options for ${cfgsdir}"
+ err "Cannot get options for ${cfgsdir}"
[ $# -gt 0 ] && targets=$@
- [ "${mode}" = "all" ] && xx_ mkdir -p "${elfdir}/"
+ [ -z ${mode} ] && x_ mkdir -p "${elfdir}/"
+
+ handle_targets
}
handle_targets()
@@ -47,12 +92,12 @@ handle_targets()
target="${x}"
printf "Running 'make %s' for project '%s, target '%s''\n" \
"${mode}" "${project}" "${target}"
- [ "${project}" != "coreboot" ] || [ "${mode}" != "all" ] || \
- xx_ ./update blobs download ${target}
- xx_ handle_defconfig
+ [ "${project}" != "coreboot" ] || [ ! -z ${mode} ] || \
+ x_ ./update blobs download ${target}
+ x_ handle_defconfig
done
- [ "${mode}" = "all" ] || return 0
+ [ -z ${mode} ] || return 0
printf "Done! The files are stored under %s/\n\n" "${elfdir}"
}
@@ -68,30 +113,30 @@ handle_defconfig()
printf "handle/make/config %s %s: handling config %s\n" \
"${project}" "${target}" "${config_name}"
- [ "${mode}" != "all" ] || check_config || continue
- run_make_command
- [ "${mode}" != "all" ] || copy_elf
+ [ ! -z ${mode} ] || check_config || continue
+ handle_makefile
+ [ ! -z ${mode} ] || copy_elf
done
}
handle_src_tree()
{
target_dir="${cfgsdir}/${target}"
- xx_ mkdir -p "${elfdir}/${target}"
+ x_ mkdir -p "${elfdir}/${target}"
eval "$(setvars "" arch tree)"
romtype="normal"
[ -f "${target_dir}/target.cfg" ] || \
- fail "handle_src_tree: ${target_dir}: missing target.cfg"
+ err "handle_src_tree: ${target_dir}: missing target.cfg"
# Override the above defaults using target.cfg
. "${target_dir}/target.cfg" # source
[ -z ${tree} ] && \
- fail "handle_src_tree: ${target_dir}: tree undefined"
+ err "handle_src_tree: ${target_dir}: tree undefined"
[ -z ${arch} ] && \
- fail "handle_src_tree: ${target_dir}: undefined cpu type"
+ err "handle_src_tree: ${target_dir}: undefined cpu type"
codedir="${project}/${tree}"
if [ ! -d "${codedir}" ]; then
@@ -101,7 +146,7 @@ handle_src_tree()
"${codedir}" 1>&2
return 1
fi
- xx_ ./update project trees "${project}" "${target}"
+ x_ ./update project trees "${project}" "${target}"
elif [ "${mode}" = "distclean" ] || \
[ "${mode}" = "crossgcc-clean" ]; then
[ -f "${tmpclean}/${tree}" ] && return 1
@@ -110,10 +155,10 @@ handle_src_tree()
# u-boot and coreboot are both compiled with coreboot's crossgcc
if [ "${project}" = "coreboot" ] || [ "${project}" = "u-boot" ]; then
- [ "${mode}" != "all" ] || check_cross_compiler || \
- fail "handle_src_tree ${project}/${target}: crossgcc"
+ [ ! -z ${mode} ] || check_cross_compiler || \
+ err "handle_src_tree ${project}/${target}: crossgcc"
cbfstool="cbutils/${tree}/cbfstool"
- [ -f "${cbfstool}" ] || xx_ ./build coreboot utils "${tree}"
+ [ -f "${cbfstool}" ] || x_ ./build coreboot utils "${tree}"
fi
}
@@ -134,7 +179,7 @@ check_cross_compiler()
# only true if not building coreboot:
ctarget="${cbdir#coreboot/}"
[ -d "${cbdir}" ] || \
- xx_ ./update project trees coreboot ${ctarget}
+ x_ ./update project trees coreboot ${ctarget}
if [ "${arch}" = "x86_32" ] || [ "${arch}" = "x86_64" ]; then
[ -d "${cbdir}/util/crossgcc/xgcc/i386-elf/" ] || \
@@ -173,7 +218,7 @@ check_cross_compiler()
check_config()
{
[ ! -f "${config}" ] && \
- fail "check_config: ${project}/${target}: configs missing"
+ err "check_config: ${project}/${target}: configs missing"
dest_dir="${elfdir}/${target}/${config_name}"
# TODO: very hacky check. do it properly (based on build.list)
@@ -182,73 +227,75 @@ check_config()
printf "Build already exists, so skipping build\n" 1>&2
return 1
done
- xx_ mkdir -p "${dest_dir}"
+ x_ mkdir -p "${dest_dir}"
}
-run_make_command()
+handle_makefile()
{
- xx_ ./handle make file -c "${codedir}"
- xx_ cp "${config}" "${codedir}/.config"
- [ "${mode}" != "all" ] || make -C "${codedir}" silentoldconfig || \
- make -C "${codedir}" oldconfig || : # don't error on oldconfig
-
- if [ "${project}" = "coreboot" ] && [ "${mode}" = "all" ]; then
- printf "%s\n" "${our_version}" >"${codedir}/.coreboot-version" \
- || fail "run_make_command: ${codedir}: can't set version"
- fi
- xx_ make -C "${codedir}" -j$(nproc) ${mode}
+ x_ make clean -C "${codedir}"
+ x_ cp "${config}" "${codedir}/.config"
+ [ ! -z ${mode} ] || make -C "${codedir}" silentoldconfig || \
+ make -C "${codedir}" oldconfig || :
+
+ run_make_command || err "handle_makefile ${codedir}: no makefile!"
if [ -e "${codedir}/.git" ] && [ "${project}" = "u-boot" ] && \
[ "${mode}" = "distclean" ]; then
- xx_ git -C "${codedir}" clean -fdx
+ x_ git -C "${codedir}" clean -fdx
elif [ "${mode}" = "oldconfig" ] || [ "${mode}" = "menuconfig" ]; then
- xx_ cp "${codedir}/.config" "${config}"
+ x_ cp "${codedir}/.config" "${config}"
fi
}
+run_make_command()
+{
+ [ -f "${codedir}/Makefile" ] || [ -f "${codedir}/makefile" ] || \
+ [ -f "${codedir}/GNUmakefile" ] || return 1
+ [ "${project}" = "coreboot" ] && [ -z ${mode} ] && \
+ x_ printf "%s\n" "${version}" >"${codedir}/.coreboot-version"
+
+ x_ make -C "${codedir}" -j$(nproc) ${mode}
+ [ "${mode}" != "clean" ] && return 0
+ make -C "${codedir}" distclean 2>/dev/null || :
+}
+
copy_elf()
{
- [ "${project}" != "coreboot" ] || xx_ modify_coreboot_rom
+ [ "${project}" != "coreboot" ] || x_ modify_coreboot_rom
while read f; do
[ ! -f "${codedir}/$f" ] || \
- xx_ cp "${codedir}/${f}" "${dest_dir}/"
+ x_ cp "${codedir}/${f}" "${dest_dir}/"
done < ${listfile}
- xx_ ./handle make file -c "${codedir}"
+ x_ make clean -C "${codedir}"
}
modify_coreboot_rom()
{
rompath="${codedir}/build/coreboot.rom"
[ -f "${rompath}" ] || \
- fail "modify_coreboot_rom: does not exist: ${rompath}"
+ err "modify_coreboot_rom: does not exist: ${rompath}"
tmprom="$(mktemp -t rom.XXXXXXXXXX)"
- xx_ rm -f "${tmprom}"
+ x_ rm -f "${tmprom}"
if [ "${romtype}" = "d8d16sas" ]; then
# pike2008 roms hang seabios. an empty rom will override
# the built-in one, thus disabling all execution of it
- xx_ touch "${tmprom}"
+ x_ touch "${tmprom}"
for deviceID in "0072" "3050"; do
- xx_ "${cbfstool}" "${rompath}" add -f "${tmprom}" \
+ x_ "${cbfstool}" "${rompath}" add -f "${tmprom}" \
-n "pci1000,${deviceID}.rom" -t raw
done
elif [ "${romtype}" = "i945 laptop" ]; then
# for bucts-based installation method from factory bios
- xx_ dd if="${rompath}" of="${tmprom}" bs=1 \
+ x_ dd if="${rompath}" of="${tmprom}" bs=1 \
skip=$(($(stat -c %s "${rompath}") - 0x10000)) \
count=64k
- xx_ dd if="${tmprom}" of="${rompath}" bs=1 \
+ x_ dd if="${tmprom}" of="${rompath}" bs=1 \
seek=$(($(stat -c %s "${rompath}") - 0x20000)) \
count=64k conv=notrunc
fi
- xx_ rm -f "${tmprom}"
-}
-
-fail()
-{
- [ -z "${codedir}" ] || ./handle make file -c "${codedir}" || :
- err "${1}"
+ x_ rm -f "${tmprom}"
}
main $@
diff --git a/script/build/release/src b/script/build/release/src
index 1a504133..36bd68ca 100755
--- a/script/build/release/src
+++ b/script/build/release/src
@@ -101,12 +101,12 @@ purge_files()
(
x_ cd "${srcdir}/"
[ ! -d "coreboot/default/util/kbc1126" ] || \
- x_ ./handle make file -c "coreboot/default/util/kbc1126"
- x_ ./handle make config -x coreboot
+ x_ ./build project trees -c "coreboot/default/util/kbc1126"
+ x_ ./build project trees -x coreboot
for p in u-boot seabios coreboot; do
- x_ ./handle make config -c "${p}"
+ x_ ./build project trees -c "${p}"
done
- x_ ./handle make file -c bios_extract flashrom grub uefitool \
+ x_ ./build project trees -c bios_extract flashrom grub uefitool \
util-fw/stm32-vserprog util-fw/stm32-vserprog/libopencm3 \
memtest86plus/build32 memtest86plus/build64 util/*
diff --git a/script/handle/make/file b/script/handle/make/file
deleted file mode 100755
index ff41f375..00000000
--- a/script/handle/make/file
+++ /dev/null
@@ -1,40 +0,0 @@
-#!/usr/bin/env sh
-# SPDX-License-Identifier: GPL-3.0-or-later
-# SPDX-FileCopyrightText: 2023 Leah Rowe <leah@libreboot.org>
-
-[ "x${DEBUG+set}" = 'xset' ] && set -v
-set -u -e
-
-. "include/err.sh"
-. "include/make.sh"
-
-eval "$(setvars "" mode project _flag codedir)"
-
-# main() is in include/make.sh
-
-handle_dependencies()
-{
- [ $# -gt 0 ] && x_ ./handle make file ${_flag} ${@}
-
- [ -d "${project}" ] || x_ ./update project repo "${project%/*}"
- [ -d "${project}" ] || \
- err "handle_dependencies: ${project%/*} not downloaded"
-
- [ "${project}" = "uefitool" ] || return 0 # TODO: remove hardcoding
- (
- x_ cd uefitool
- cmake UEFIExtract/ || [ -f Makefile ] || \
- err "handle_dependencies: !cmake UEFIExtract/"
- )
-}
-
-handle_targets()
-{
- [ -f "${project}/Makefile" ] || [ -f "${project}/makefile" ] || \
- [ -f "${project}/GNUmakefile" ] || return 0
- [ "${mode}" = "all" ] && x_ make -C "${project}" -j$(nproc) && return 0
- x_ make -C "${project}" clean
- make -C "${project}" distclean 2>/dev/null || :
-}
-
-main $@
diff --git a/script/update/blobs/download b/script/update/blobs/download
index fef6b2c6..735a5452 100755
--- a/script/update/blobs/download
+++ b/script/update/blobs/download
@@ -47,7 +47,7 @@ build_dependencies()
x_ ./update project repo "${d}"
done
[ -f uefitool/uefiextract ] || \
- x_ ./handle make file -b uefitool
+ x_ ./build project trees -b uefitool
[ -f "${cbdir}/util/kbc1126/kbc1126_ec_dump" ] || \
x_ make -C "${cbdir}/util/kbc1126"
x_ ./build coreboot utils default